function GearMotion()
clc
clearvars
close all
dbstop error



%%Data
numrevolution=.5;%number of revolution fo the first gear
numframe=360;%fram for revolution

%% Gear1
Gear1.m=3;%modulus
Gear1.z=22;%number of teeth
Gear1.Alpha=20;%Pressure angle degree
Gear1.Addendum=1;%addendum/modulus ratio
Gear1.Dedendum=1.25;%dedendum/modulus ratio
Gear1.FaceWidth=10;
Gear1.ShaftDiameter=10;%shaft diameter [mm]
Gear1.numpoint=10;
Gear1.t=[];
Gear1.p=[];


Gear1=GearDesign(Gear1,false);


%% Gear2

Gear2.m=3;%modulus
Gear2.z=21;%number of teeth
Gear2.Alpha=20;%Pressure angle degree
Gear2.Addendum=1;%addendum/modulus ratio
Gear2.Dedendum=1.25;%dedendum/modulus ratio
Gear2.FaceWidth=10;
Gear2.ShaftDiameter=10;%shaft diameter [mm]
Gear2.numpoint=10;
Gear2.t=[];
Gear2.p=[];


Gear2=GearDesign(Gear2,false);


%% PLot Gears

%find axes distance and move the second gear
r1=Gear1.m*Gear1.z/2;
r2=Gear2.m*Gear2.z/2;
I=r1+r2;%axes distance
Gear2.p(:,1)=Gear2.p(:,1)+I;

if (mod(Gear2.z,2))<1%only rotate when the second gear has odd teeth number
%find the pitch and rotate the first gear
dpitch=pi/Gear1.z;
[Gear1.p(:,1),Gear1.p(:,2)]=Rotate(Gear1,0,dpitch);
end

step=2*pi/numframe;
GearRatio=Gear2.z/Gear1.z;


Gear1plot=Gear1;
Gear2plot=Gear2;
currentstep=0;
for i=1:numrevolution*numframe
    
    %rotation
    [Gear1plot.p(:,1),Gear1plot.p(:,2)]=Rotate(Gear1,0,currentstep);
     [Gear2plot.p(:,1),Gear2plot.p(:,2)]=Rotate(Gear2,I,-currentstep/GearRatio);
    
      currentstep=currentstep+step;
      
      
      %plot
figure(1)

hold off
trisurf(Gear1plot.t,Gear1plot.p(:,1),Gear1plot.p(:,2),Gear1plot.p(:,3),'facecolor',[.5 .5 .5],'edgecolor','none')
hold on
axis equal
view(2)
axis([-r1, I+r2, -max([r1,r2]),max([r1,r2]),0 ,10]) 
trisurf(Gear2plot.t,Gear2plot.p(:,1),Gear2plot.p(:,2),Gear2plot.p(:,3),'facecolor',[.5 .5 .5],'edgecolor','none')

end

end



function  [xnew,ynew]=Rotate(Gear,trasl,angle)

x=Gear.p(:,1)-trasl;%move it to the origin
y=Gear.p(:,2);

xnew=x*cos(angle)+y*sin(angle)+trasl;%rotate and move it back
ynew=-x*sin(angle)+y*cos(angle);



end
